<template>
    <div class="card">
        <h5 class="card-header">
            ID: {{ id }}
        </h5>
        <div class="card-body">
            <div class="row">
                <div class="col-2">
                    <img
                        :src="image"
                        class="img-fluid"
                    />
                </div>
                <div class="col">
                    <ul class="list-group list-group-flush">
                        <li class="list-group-item">
                            Nome: {{ name | properCase }}
                        </li>
                        <li class="list-group-item">
                            Cor: {{ color | properCase }}
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="card-footer">
            <div class="form-group">
                <label for="select_name">Escolha um Nome:</label>
                <input
                    v-model="select.name"
                    type="text"
                    class="form-control"
                    id="select_name"
                >
            </div>
            <div class="form-group">
                <label for="select_color">Escolha uma Cor:</label>
                <select
                    v-model="select.color"
                    class="form-control"
                    id="select_color"
                >
                    <option
                        v-for="(col, n) in colors"
                        :key="n"
                        :value="col"
                    >
                        {{ col | properCase }}
                    </option>
                </select>
            </div>
            <button
                class="btn btn-success"
                @click="update"
            >
                Atualizar
            </button>
            <button
                class="btn btn-danger"
                @click="del"
            >
                Deletar
            </button>
        </div>
    </div>
</template>

<script>
    export default {
        props: [
            'id',
            'color',
            'name',
        ],

        data() {
            return {
                colors: [
                    'red',
                    'green',
                ],
                select: {
                    name: '',
                    color: '',
                },
            };
        },

        filters: {
            properCase(string) {
                return string.charAt(0).toUpperCase() + string.slice(1);
            }
        },

        computed: {
            image() {
                return `/img/${this.color}.png`;
            }
        },

        methods: {
            del() {
                this.$emit('delete', this.id);
            },
            update() {
                this.$emit('update', this.id, this.select);
                this.select.name = '';
            },
        },

        watch: {
            color(val) {
                this.select.color = val;
            }
        },

        mounted() {
            this.select.color = this.color;

            this.$emit('colors', this.colors);
        },
    };
</script>
